/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package org.milaifontanals;

import org.milaifontanals.empresa.Departament;
import org.milaifontanals.empresa.Empleat;
import org.milaifontanals.persistence.EPBaseX;
import org.milaifontanals.persistence.EPBaseXException;

/**
 *
 * @author Usuari
 */
public class ProvaEPBaseX {

    public static void main(String[] args) {
        EPBaseX cp = null;
        try {
            cp = new EPBaseX();
            System.out.println("Connexió establerta");
        } catch (Exception ex) {
            System.out.println("Problema en crear la capa de persistència");
            infoError(ex);
            return;
        }

        /* Comprovació de mètode getEmpresa() */
        try {
            System.out.println("Recuperació empresa: " + cp.getEmpresa());
        } catch (EPBaseXException ex) {
            infoError(ex);
        }
        
        System.out.println("Prova de getDepartament");
        int tprova1[] = {-5, 10, 90};
        for (int codi : tprova1) {
            System.out.println("Cerquem departament de codi " + codi + ": ");
            try {
                Departament d = cp.getDepartament(codi);
                System.out.println(d);
            } catch (Exception ex) {
                System.out.println("Problema en recuperar el departament");
                infoError(ex);
            }
        }
        
        System.out.println("\nProva de getEmpleat");
        int tprova2[] = {-1000, 7839, 7844, 9999};
        for (int codi : tprova2) {
            System.out.println("Cerquem empleat de codi " + codi + ": ");
            try {
                Empleat e = cp.getEmpleat(codi);
                System.out.println(e);
            } catch (EPBaseXException ex) {
                System.out.println("Problema en recuperar l'empleat");
                infoError(ex);
            }
        }
        
        
        /* Feina de l'aplicació */

        try {
            cp.closeCapa();
            System.out.println("Capa de persistència tancada");
        } catch (Exception ex) {
            System.out.println("Error en tancar la capa de persistència");
            infoError(ex);
        }

    }

    private static void infoError(Throwable aux) {
        do {
            if (aux.getMessage() != null) {
                System.out.println("\t" + aux.getMessage());
            }
            aux = aux.getCause();
        } while (aux != null);
    }

}
