/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals;

import org.milaifontanals.empresa.Departament;
import org.milaifontanals.empresa.Empleat;
import org.milaifontanals.persistence.EPXQJ;
import org.milaifontanals.persistence.EPXQJException;

/**
 *
 * @author Usuari
 */
public class ProvaEPXQJ {

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Cal executar el programa passant el nom del fitxer de propietats com argument");
            return;
        }
        EPXQJ cp = null;
        try {
            cp = new EPXQJ(args[0]);
            System.out.println("Capa creada");
        } catch (Exception ex) {
            System.out.println("Problema en crear la capa de persistència");
            infoError(ex);
            return;
        }
        /* Treball amb la capa */
        try {
            // Comprovar mètode getEmpresa
            System.out.println("Empresa: " + cp.getEmpresa());
        } catch (Exception ex) {
            System.out.println("");
            infoError(ex);
        }
        System.out.println("Prova de getDepartament");
        int tprova1[] = {-5, 10, 90};
        for (int codi : tprova1) {
            System.out.println("Cerquem departament de codi " + codi + ": ");
            try {
                Departament d = cp.getDepartament(codi);
                System.out.println(d);
            } catch (Exception ex) {
                System.out.println("Problema en recuperar el departament");
                infoError(ex);
            }
        }

//        System.out.println("\nProva de getEmpleat");
//        int tprova2[] = {-1000, 7839, 7844, 9999};
//        for (int codi : tprova2) {
//            System.out.println("Cerquem empleat de codi " + codi + ": ");
//            try {
//                Empleat e = cp.getEmpleat(codi);
//                System.out.println(e);
//            } catch (EPXQJException ex) {
//                System.out.println("Problema en recuperar l'empleat");
//                infoError(ex);
//            }
//        }
//        System.out.println("\nProva de comptarSubordinats");
//        int tprova3[] = {-1000, 7839, 7844, 7902, 9999};
//        for (int codi : tprova3) {
//            System.out.print("Qtat subordinats d'empleat amb " + codi + ": ");
//            try {
//                int q = cp.comptarSubordinats(codi);
//                System.out.println(q);
//            } catch (EPXQJException ex) {
//                System.out.println("\nProblema en comptar subordinats de l'empleat" + codi);
//                infoError(ex);
//            }
//        }
//
//        System.out.println("\nProva de esSubordinatDirecteIndirecte");
//        int tprova4[] = {7902, 7902, 7839, 7698}; // Empleats pels que comprovarem subordinats directe/indirecte
//        int emp[] = {7839, 7369, 7369, 7369}; // Empleats a mirar si són subordinats directe/indirecte
//        /* En situació original de la BD:
//           Subordinats de 7839: 7566 - 7698 - 7782
//           Subordinats de 7566: 7788 - 7902
//           Subordinats de 7698: 7499 - 7521 - 7654 - 7844 - 7900
//           Subordinats de 7782: 7934
//           Subordinats de 7788: 7876
//           Subordinats de 7902: 7369
//         */
//        for (int i = 0; i < tprova4.length; i++) {
//            try {
//                System.out.println("Empleat " + tprova4[i] + " te per subordinat dir/ind l'empleat " + emp[i] + "? " + cp.esSubordinatDirecteIndirecte(tprova4[i], emp[i]));
//            } catch (EPXQJException ex) {
//                System.out.println("Problema en recuperar l'empleat");
//                infoError(ex);
//            }
//        }
//
//        System.out.println("\nProva d'eliminar empleat");
//        int tprova5[] = {-1000, 7782, 7902, 7902, 7566, 7566, 7566};
//        int actCap[] = {0, 0, -1, 7900, 7788, 7876, 7698};
//        /* En situació original de la BD:
//            El 7782 té 1 subordinat: 7934
//            El 7902 té 1 subordinat: 7369
//            El 7566 té subordinat 7788 (->7876): Fem 2 proves: 
//                La primera intentant substituir 7566 per subordinat directe 7788
//                La segona intentant substituir 7566 per subordinat indirecte 7876
//                La tercera intentant substituir 7566 per 7698 que no és subordinat (directe ni indirecte) 
//         */
//        for (int i = 0; i < tprova5.length; i++) {
//            try {
//                System.out.println("Crida eliminarEmpleat(" + tprova5[i] + "," + actCap[i] + ")");
//                cp.eliminarEmpleat(tprova5[i], actCap[i]);
//                cp.commit();
//                System.out.println("Eliminació efectuada!");
//            } catch (EPXQJException ex) {
//                System.out.println("Problema en eliminar empleat " + tprova5[i]);
//                infoError(ex);
//            }
//        }

        try {
            cp.closeCapa();
            System.out.println("Capa tancada");
        } catch (EPXQJException ex) {
            System.out.println("Error en tancar la capa de persistència");
            infoError(ex);
        }

    }

    private static void infoError(Throwable aux) {
        do {
            if (aux.getMessage() != null) {
                System.out.println("\t" + aux.getMessage());
            }
            aux = aux.getCause();
        } while (aux != null);
    }

}
