-- DIRECTORY en Oracle: s un lies creat dins Oracle per a fer referncia
--                      a una carpeta fsica del sistema d'arxius de la mquina
--                      on hi ha l'Oracle installat.
-- Quan des d'Oracle s'ha d'accedir a una carpeta fsica del sistema, per exemple,
-- per carregar un arxiu o per exportar un arxiu, es necessita tenir un DIRECTORY
-- per poder-hi accedir. Tots els accessos es fan via el DIRECTORY.

-- Com que volem incorporar arxius XML (mondial.xml, empresa.xml,...) dins Oracle
-- ens cal tenir el DIRECTORY dins Oracle mapant la carpeta fsica on tenim els arxius

-- Com CREAR/ESBORRAR UN DIRECTORY:
-- El pot crear/esborrar l'usuari SYSTEM 
-- o un usuari que tingui els privilegis "create any directory" i/o "drop any directory"
-- Ordre SQL: 
create directory NOM_DIRECTORI as 'c:\carpetaOnEsVolAccedir';
-- Tamb es pot crear des de SQLDeveloper
-- En el moment de crear-se, la carpeta fsica pot no existir i no es queixa,
-- per els problemes apareixerien en intentar accedir a la carpeta fsica
-- ALERTES!!!
-- * Si es desitja tenir el nom del directory case-sensitive, en crear-lo cal
--   escriure el nom entre "". Del contrari, Oracle el guarda en majscules
-- * Si s SYSTEM qui crea un DIRECTORY, llavors cal assignar privilegi de lectura i/o escriptura
--   a tothom (public) o a l'usuari que l'hagi d'utilitzar. "Lectura" si s per passar
--   informaci de la carpeta fsica a la BD i "Escriptura" en direcci contrria.
--   EPS!!! Ara s'est parlant de privilegis sobre el DIRECTORY creat a Oracle; 
--   s diferent dels privilegis sobre la carpeta del servidor (alerta segent)
--   Es pot fer via grant/revoque o des de SQLDeveloper
-- * FONAMENTAL que la carpeta del servidor tingui privilegi (com a mnim) de
--   lectura per a tothom (en particular per al Servidor Oracle). 
--   Del contrari, quan s'hi intenti accedir per agafar 
--   documents (per bolcar-los, per exemple, al repositori XML) pot aparixer error:
--      Datos no vlidos.
--      ORA-06512: a "SYS.DBMS_LOB", line 822
--      ORA-06512: a "XDB.DBMS_XDB", line 301
--      ORA-06512: a line 4
--      22288. 00000 -  "file or LOB operation %s failed\n%s"

-- REPOSITORI XML d'Oracle: Espai on Oracle guarda els documents XML, com si fos SGBD XML
-- El repositori resideix dins l'esquema XDB d'Oracle
-- En el seu interior hi ha carpetes (com colleccions) que permeten tenir la informaci
-- organitzada: veure contingut des de SQLDeveloper amb usuari "alumne".
-- Si mirem l'interior des d'usuaris SYS/SYSTEM veurem ms carpetes.
-- Observem l'existncia de carpeta "/public", accessible per tot usuari

-- Com CREAR una carpeta (COL.LECCI). Un usuari normal ("alumne") noms t perms
-- per crear carpetes dins "/public" del repositori
-- Crear una carpeta (es pot fer des de SQLDeveloper):
declare
  resultat boolean;
begin
  resultat:=DBMS_XDB.createfolder('/public/geografia');
  commit;
end;
/
-- Com AFEGIR un recurs (arxiu XML, imatge,...) en una carpeta 
-- (cal tenir creat un DIRECTORY que mapegi la carpeta fsica on anem a cercar el recurs)
declare
  resultat boolean;
begin
  resultat:=dbms_xdb.createresource('/public/geografia/mondial.xml',
                                    BFILENAME('NOM_DIRECTORI','mondial.xml'));
  -- El parmetre "directory" de la funci bFilename (1r. parmetre) s case sensitive
  commit;
end;
-- COMPTE si el document XML cont etiqueta DOCTYPE:
--   El procediment createresource d'Oracle18c+ no es queixa
--   En alguna versi anterior es queixava i calia incorporar tota la ruta d'ubicaci del .dtd,
--   com per exemple: <!DOCTYPE mondial SYSTEM "/public/geografia/mondial.dtd">

-- Com ELIMINAR un recurs (carpeta o fitxer)
-- Per eliminar una carpeta (que ha d'estar buida):
CALL DBMS_XDB.deleteresource('/public/geografia');
COMMIT;
-- o dins un bloc PL/SQL:
begin
    DBMS_XDB.deleteresource('/public/geografia');
    commit;
end;
-- Per eliminaci recursiva, cal invocar procedure deleteresource amb parmetre delete_recursive
-- i per poder passar una constant definida en un package, cal invocar-ho des de bloc PL/SQL:
begin
    DBMS_XDB.deleteresource('/public/geografia',DBMS_XDB.delete_recursive); 
    COMMIT;
end;
-- Per elininar un fitxer concret:
CALL DBMS_XDB.deleteresource('/public/geografia/mondial.xml');  
COMMIT;
-- o
begin
    DBMS_XDB.deleteresource('/public/geografia/mondial.xml');  
    COMMIT;
end;



